﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace esemeny_delegalt
{
    public delegate void NaplozoDelegalt(string uzenet, DateTime ido);
    public partial class Form1 : Form
    {
        NaplozoDelegalt naplozopeldany;
        public Form1()
        {
            InitializeComponent();
            nyero.Nyert += new EventHandler(nyero_Nyert);
            naplozopeldany = NaplozasFljba;
            naplozopeldany += delegate(string uzenet, DateTime ido)
            {
                Console.WriteLine(uzenet + ido.ToShortTimeString());
            };
        }

        void NaplozasFljba(string uzenet, DateTime ido)
        {
            StreamWriter sw = new StreamWriter(@"naplo.txt", true);
            sw.WriteLine(uzenet + ido.ToShortTimeString());
            sw.Close();
        }

        void nyero_Nyert(object sender, EventArgs e)
        {
            MessageBox.Show("Nyert");
            if (naplozopeldany != null)
            { naplozopeldany("A tippelő  nyert", DateTime.Now); }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Test");
        }
        private void Button1_katt(object sender, EventArgs e)
        {
            Console.WriteLine("zuper");
        }

        Nyerő nyero = new Nyerő();
        private void button2_Click(object sender, EventArgs e)
        {
            nyero.Tipp = int.Parse(textBox1.Text);
        }
    }
}
