﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Időjárás
{
    public partial class Form1 : Form
    {
        List<Elorejelzes> elorejelzesek = new List<Elorejelzes>();
        Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();
            comboBox1.DataSource = Enum.GetValues(typeof(Regiok));
            DateTime ma = DateTime.Now;
            for (int i = 0; i < 10; i++)
            {
                foreach (Regiok r in Enum.GetValues(typeof(Regiok)))
                {
                    int min = rnd.Next(5, 20);
                    elorejelzesek.Add(new Elorejelzes(ma.AddDays(i), r, (Jellegek)rnd.Next(0,Enum.GetValues(typeof(Jellegek)).Length), min, min+rnd.Next(0,15)));

                }
            }
            listBox1.DataSource = elorejelzesek;
        }

        private void regiobtn_Click(object sender, EventArgs e)
        {
            var regioszerint = elorejelzesek.Where(x => x.Regio ==(Regiok)(comboBox1.SelectedItem));
            listBox1.DataSource = regioszerint;
            //Print(regioszerint); 
        }

        private void idobtn_Click(object sender, EventArgs e)
        {

        }

        void Print(IEnumerable list)
        {
            listBox1.DataSource = list;
            foreach (var item in list)
            {
                listBox1.Items.Add(item);
                Console.WriteLine(item);
            }
            Console.WriteLine(@"---------------------");
        }
    }
}
