﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace lambda_linq
{
    //delegate string StrinConverterDelegate(string s);
    class Program
    {

        static void Main(string[] args)
        {
            //StrinConverterDelegate StringconverterInstance;
            //metódussal
            //StringconverterInstance = Convert1;
            //StringconverterInstance = new StrinConverterDelegate(Convert1);
           
            //névtelen metódussal
            //StringconverterInstance = delegate(string s) { return s.ToUpper(); };

            //lambda kifejezés 
            //StringconverterInstance = s => s.ToUpper();

            //Func függvénnyel
            Func<string, string> StringconverterInstance = s => s.ToUpper();
            diak d = new diak("Valaki", 66);
            Console.WriteLine(StringconverterInstance(d.Nev));

            //--------LINQ------------ Language Integrated Queries
            //-----To Object-----
            List<diak> diakok = new List<diak>();
            diakok.Add(new diak("béla",88));
            diakok.Add(new diak("Anna", 48));
            diakok.Add(new diak("Csilla", 188));
            diakok.Add(new diak("Elemér", 18));
            diakok.Add(new diak("Ólasz", 999));

            var nevsor = diakok.OrderBy(x=>x.Nev);
            Print(diakok);
            /*foreach (var item in nevsor)
            {
                Console.WriteLine(item);
            }*/
            var kreditsz = diakok.OrderByDescending(x => x.Kreditek);
            Print(kreditsz);

            var kredit50 = diakok.Where(x => x.Kreditek > 50);
            Print(kredit50);

            var sok = diakok.Where(x => x.Kreditek > 50).OrderBy(x => x.Nev);
            Print(sok);

            var nev = diakok.Select(x => x.Nev);
            Print(nev);

            //50-nél több, fordítva, nagybetűvel
            //var soksok = diakok.Where(x => x.Kreditek > 50).OrderByDescending(x => x.Nev).Select(x => x.Nev.ToUpper());

            var soksok = from x in diakok
                         where x.Kreditek > 50
                         orderby x.Nev descending
                         select x.Nev.ToUpper();
            Print(soksok);

            //Aggregált fv-ek
            var atlag = diakok.Average(x => x.Kreditek);
            Console.WriteLine(String.Format("az átlag {0}",atlag));

            
            Console.ReadKey();
        }

        static string Convert1(string s)
        { return s.ToUpper(); }

        static void Print(IEnumerable list)
        {
            foreach (var item in list)
            {
                Console.WriteLine(item);
            }
            Console.WriteLine(@"---------------------");
        }
    }
}
