﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace esemeny_delegalt
{
    class Nyerő
    {
        int tipp;
        public int Tipp
        {
            get { return tipp; }
            set
            {
                tipp = value;
                if (tipp == 25)
                {
                    OnNyert(); //esemény kiváltása
                }
            }
        }

        public event EventHandler Nyert;
        void OnNyert() //eseményt kiváltó metódus
        {
            if (Nyert != null)
            { Nyert(this, null); }
        }
    }
}
