﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Időjárás
{
    public enum Regiok {EszakNyugat, DelNyugat, EszakKozep, DelKozep, EszakKelet, DelKelet };
    public enum Jellegek {Napos, KicsitFelhos, NagyonFelhos, Esos, Viharos };
    class Elorejelzes
    {
        DateTime datum;
        public DateTime Datum
        {
            get { return datum; }
        }
        Regiok regio;
        public Regiok Regio
        {
            get { return regio; }
        }
        Jellegek jelleg;
        public Jellegek Jelleg
        {
            get { return jelleg; }
        }
        int min;
        public int Min
        {
            get { return min; }
        }
        int max;
        public int Max
        {
            get { return max; }
        }
        public Elorejelzes(DateTime datum, Regiok regio, Jellegek jelleg, int min, int max)
        {
            this.datum = datum;
            this.regio = regio;
            this.jelleg = jelleg;
            this.min = min;
            this.max = max;
        }
        public override string ToString()
        {
            return regio.ToString().PadRight(12)+datum.ToShortDateString()+" "+jelleg.ToString().PadRight(13)+min.ToString().PadLeft(3)+max.ToString().PadLeft(3);
        }
    }
}
